=== wscript ===
#!/usr/bin/env python

# Copyright Joyent, Inc. and other Node contributors.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to permit
# persons to whom the Software is furnished to do so, subject to the
# following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
# NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
# USE OR OTHER DEALINGS IN THE SOFTWARE.

import re
import Options
import sys, os, shutil, glob
import Utils
from Utils import cmd_output
from os.path import join, dirname, abspath, normpath
from logging import fatal

cwd = os.getcwd()
APPNAME="node.js"

# Use the directory that this file is found in to find the tools
# directory where the js2c.py file can be found.
sys.path.append(sys.argv[0] + '/tools');
import js2c

if sys.platform.startswith("cygwin"):
  print "cygwin not supported"
  sys.exit(1)

srcdir = '.'
blddir = 'out'
supported_archs = ('arm', 'ia32', 'x64') # 'mips' supported by v8, but not node

jobs=1
if os.environ.has_key('JOBS'):
  jobs = int(os.environ['JOBS'])

def safe_path(path):
  return path.replace("\\", "/")

def canonical_cpu_type(arch):
  m = {'x86': 'ia32', 'i386':'ia32', 'x86_64':'x64', 'amd64':'x64'}
  if arch in m: arch = m[arch]
  if not arch in supported_archs:
    raise Exception("supported architectures are "+', '.join(supported_archs)+\
                    " but NOT '" + arch + "'.")
  return arch

def set_options(opt):
  # the gcc module provides a --debug-level option
  opt.tool_options('compiler_cxx')
  opt.tool_options('compiler_cc')
  opt.tool_options('misc')
  opt.add_option( '--libdir'
                , action='store'
                , type='string'
                , default=False
                , help='Install into this libdir [Release: ${PREFIX}/lib]'
                )
  opt.add_option( '--debug'
                , action='store_true'
                , default=False
                , help='Build debug variant [Release: False]'
                , dest='debug'
                )
  opt.add_option( '--profile'
                , action='store_true'
                , default=False
                , help='Enable profiling [Release: False]'
                , dest='profile'
                )
  opt.add_option( '--efence'
                , action='store_true'
                , default=False
                , help='Build with -lefence for debugging [Release: False]'
                , dest='efence'
                )

  opt.add_option( '--without-npm'
                , action='store_true'
                , default=False
                , help='Don\'t install the bundled npm package manager [Release: False]'
                , dest='without_npm'
                )

  opt.add_option( '--without-snapshot'
                , action='store_true'
                , default=False
                , help='Build without snapshotting V8 libraries. You might want to set this for cross-compiling. [Release: False]'
                , dest='without_snapshot'
                )

  opt.add_option( '--without-ssl'
                , action='store_true'
                , default=False
                , help='Build without SSL'
                , dest='without_ssl'
                )


  opt.add_option('--shared-v8'
                , action='store_true'
                , default=False
                , help='Link to a shared V8 DLL instead of static linking'
                , dest='shared_v8'
                )

  opt.add_option( '--shared-v8-includes'
                , action='store'
                , default=False
                , help='Directory containing V8 header files'
                , dest='shared_v8_includes'
                )

  opt.add_option( '--shared-v8-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared V8 DLL'
                , dest='shared_v8_libpath'
                )

  opt.add_option( '--shared-v8-libname'
                , action='store'
                , default=False
                , help="Alternative lib name to link to (default: 'v8')"
                , dest='shared_v8_libname'
                )

  opt.add_option( '--openssl-includes'
                , action='store'
                , default=False
                , help='A directory to search for the OpenSSL includes'
                , dest='openssl_includes'
                )

  opt.add_option( '--openssl-libpath'
                , action='store'
                , default=False
                , help="A directory to search for the OpenSSL libraries"
                , dest='openssl_libpath'
                )

  opt.add_option( '--no-ssl2'
                , action='store_true'
                , default=False
                , help="Disable OpenSSL v2"
                , dest='openssl_nov2'
                )

  opt.add_option( '--gdb'
                , action='store_true'
                , default=False
                , help="add gdb support"
                , dest='use_gdbjit'
                )


  opt.add_option( '--shared-zlib'
                , action='store_true'
                , default=False
                , help='Link to a shared zlib DLL instead of static linking'
                , dest='shared_zlib'
                )

  opt.add_option( '--shared-zlib-includes'
                , action='store'
                , default=False
                , help='Directory containing zlib header files'
                , dest='shared_zlib_includes'
                )

  opt.add_option( '--shared-zlib-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared zlib DLL'
                , dest='shared_zlib_libpath'
                )


  opt.add_option( '--shared-cares'
                , action='store_true'
                , default=False
                , help='Link to a shared C-Ares DLL instead of static linking'
                , dest='shared_cares'
                )

  opt.add_option( '--shared-cares-includes'
                , action='store'
                , default=False
                , help='Directory containing C-Ares header files'
                , dest='shared_cares_includes'
                )

  opt.add_option( '--shared-cares-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared C-Ares DLL'
                , dest='shared_cares_libpath'
                )


  opt.add_option( '--with-dtrace'
                , action='store_true'
                , default=False
                , help='Build with DTrace (experimental)'
                , dest='dtrace'
                )
 

  opt.add_option( '--product-type'
                , action='store'
                , default='program'
                , help='What kind of product to produce (program, cstaticlib '\
                       'or cshlib) [default: %default]'
                , dest='product_type'
                )

  opt.add_option( '--dest-cpu'
                , action='store'
                , default=None
                , help='CPU architecture to build for. Valid values are: '+\
                       ', '.join(supported_archs)
                , dest='dest_cpu'
                )

def get_node_version():
  def get_define_value(lines, define):
    for line in lines:
      if define in line:
        return line.split()[-1] #define <NAME> <VALUE>

  lines = open("src/node_version.h").readlines()
  node_major_version = get_define_value(lines, 'NODE_MAJOR_VERSION')
  node_minor_version = get_define_value(lines, 'NODE_MINOR_VERSION')
  node_patch_version = get_define_value(lines, 'NODE_PATCH_VERSION')
  node_is_release    = get_define_value(lines, 'NODE_VERSION_IS_RELEASE')

  return "%s.%s.%s%s" % ( node_major_version,
                           node_minor_version,
                           node_patch_version,
                           node_is_release == "0" and "-pre" or ""
                         )

def arch_cflags(conf):
  flags = []

  if 'DEST_CPU' in conf.env:
    arch = conf.env['DEST_CPU']
    if arch == 'ia32':
      flags += ['-m32']
    elif arch == 'x64':
      flags += ['-m64']
    if sys.platform.startswith('darwin'):
      flags += ['-arch', {'ia32':'i386', 'x64':'x86_64'}.get(arch, arch)]

  return flags

def configure(conf):
  conf.check_tool('compiler_cxx')
  if not conf.env.CXX: conf.fatal('c++ compiler not found')
  conf.check_tool('compiler_cc')
  if not conf.env.CC: conf.fatal('c compiler not found')

  o = Options.options

  if o.libdir:
    conf.env['LIBDIR'] = o.libdir
  else:
    conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib'

  conf.env["USE_DEBUG"] = o.debug
  # Snapshot building does noet seem to work on mingw32
  conf.env["SNAPSHOT_V8"] = not o.without_snapshot and not sys.platform.startswith("win32")
  if sys.platform.startswith("sunos"):
    conf.env["SNAPSHOT_V8"] = False
  conf.env["USE_PROFILING"] = o.profile

  conf.env["USE_SHARED_V8"] = o.shared_v8 or o.shared_v8_includes or o.shared_v8_libpath or o.shared_v8_libname
  conf.env["USE_SHARED_CARES"] = o.shared_cares or o.shared_cares_includes or o.shared_cares_libpath
  conf.env["USE_SHARED_ZLIB"] = o.shared_zlib or o.shared_zlib_includes or o.shared_zlib_libpath

  conf.env["USE_GDBJIT"] = o.use_gdbjit
  conf.env['USE_NPM'] = not o.without_npm

  if not conf.env["USE_SHARED_ZLIB"] and not sys.platform.startswith("win32"):
    conf.env.append_value("LINKFLAGS", "-lz")

  conf.check(lib='dl', uselib_store='DL')
  if not sys.platform.startswith("sunos") and not sys.platform.startswith("win32"):
    conf.env.append_value("CCFLAGS", "-rdynamic")
    conf.env.append_value("LINKFLAGS_DL", "-rdynamic")

  if 'bsd' in sys.platform:
    conf.check(lib='kvm', uselib_store='KVM')

  #if Options.options.debug:
  #  conf.check(lib='profiler', uselib_store='PROFILER')

  if Options.options.dtrace:
    if not sys.platform.startswith("sunos"):
      conf.fatal('DTrace support only currently available on Solaris')

    conf.find_program('dtrace', var='DTRACE', mandatory=True)
    conf.env["USE_DTRACE"] = True
    conf.env.append_value("CXXFLAGS", "-DHAVE_DTRACE=1")

  if Options.options.efence:
    conf.check(lib='efence', libpath=['/usr/lib', '/usr/local/lib'], uselib_store='EFENCE')

  if 'bsd' in sys.platform:
     if not conf.check(lib="execinfo",
                       includes=['/usr/include', '/usr/local/include'],
                       libpath=['/usr/lib', '/usr/local/lib'],
                       uselib_store="EXECINFO"):
       conf.fatal("Install the libexecinfo port from /usr/ports/devel/libexecinfo.")

  if not Options.options.without_ssl:
    # Don't override explicitly supplied openssl paths with pkg-config results.
    explicit_openssl = o.openssl_includes or o.openssl_libpath

    # Disable ssl v2 methods
    if o.openssl_nov2:
      conf.env.append_value("CPPFLAGS", "-DOPENSSL_NO_SSL2=1")

    if not explicit_openssl and conf.check_cfg(package='openssl',
                                               args='--cflags --libs',
                                               uselib_store='OPENSSL'):
      Options.options.use_openssl = conf.env["USE_OPENSSL"] = True
      conf.env.append_value("CPPFLAGS", "-DHAVE_OPENSSL=1")
    else:
