=== debian/changelog ===
nodejs (0.6.19~dfsg1-5ubuntu1) quantal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

 -- James Page <james.page@ubuntu.com>  Mon, 24 Sep 2012 10:43:19 +0100

nodejs (0.6.19~dfsg1-5) unstable; urgency=low

  * Team upload.
  * Fix node-waf so that it correctly looks for "nodejs" instead of
    "node" (patched node_addon.py)

 -- David Paleino <dapal@debian.org>  Fri, 21 Sep 2012 23:23:16 +0200

nodejs (0.6.19~dfsg1-4ubuntu1) quantal; urgency=low

  [ Daniel Holbach ]
  * Merged from Debian unstable. Remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

  [ James Page ]
  * Dropped:
    - d/patches/2005_expected_failing_tests.patch: Updated failing tests to
      include stack_overflow for armel/armhf - test relaxed in 2004 patch.

 -- James Page <james.page@ubuntu.com>  Tue, 18 Sep 2012 11:31:55 +0100

nodejs (0.6.19~dfsg1-4) unstable; urgency=medium

  * Update package relations:
    + Break only packages actually calling /usr/bin/node (directly or
      via env).
    + Tighten breaks for packages with fixed release.
  * Set urgency=medium as this change affects only packaging hints so
    should not need reset of aging timer in unstable.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 06 Aug 2012 14:51:31 +0200

nodejs (0.6.19~dfsg1-3) unstable; urgency=low

  [ Jérémy Lal ]
  * debian/patches:
    + 2012_fix_v8_3_10.patch, fix crash on exit when building
      against libv8-3.10.8.
    + 2013_waf_linkflags.patch, waf must support LINKFLAGS,
      Closes: #678563.

  [ Jonas Smedegaard ]
  * Rename binary node → nodejs:
    + Adjust paths of binary and manpage.
    + Fix avoid bogus explicit installation of debug files.
    + Adjust install scripts and add cleanup for old alternative.
    + Patch manpage to adjust command name.
    + Have binary package nodejs break any packages in Debian that
      reference /usr/bin/node.
    + Add new binary package nodejs-legacy, and have that (not nodejs)
      conflict with node.
    + Add NEWS entry.
    Closes: bug#611698, #681360. See also bug#614907. Thanks to
    tech-ctte and everyone else helping to resolve this.
  * Work around upstream shipping docs in wrong subdir, and disable huge
    patch 1002 attempting same but causing FTBFS for me. Keep patch 1002
    in source, to ease proof-reading by release team.
  * Add patch 2004 to fix FTBFS: Relax a test to work with slightly
    different output when linked against recent v8.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Jul 2012 11:19:38 +0200

nodejs (0.6.19~dfsg1-2ubuntu3) quantal; urgency=low

  * Really fix FTBFS on arm* architectures.

 -- James Page <james.page@ubuntu.com>  Mon, 09 Jul 2012 17:02:19 +0100

nodejs (0.6.19~dfsg1-2ubuntu2) quantal; urgency=low

  * Fix FTBFS on arm* architectures:
    - d/patches/2005_expected_failing_tests.patch: Updated failing tests to 
      include stack_overflow for armel/armhf.

 -- James Page <james.page@ubuntu.com>  Mon, 09 Jul 2012 16:02:23 +0100

nodejs (0.6.19~dfsg1-2ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

 -- James Page <james.page@ubuntu.com>  Mon, 11 Jun 2012 12:37:26 +0100

nodejs (0.6.19~dfsg1-2) unstable; urgency=low

  * debian/patches:
    + 2005_expected_failing_tests.patch, more tests can timeout.
    + 1002_upstream_forgot_to_build_doc.patch, include docs from
      late release of version 0.6.19.
  * debian/nodejs.docs:
    + update path
    + include markdown files.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 06 Jun 2012 23:35:37 +0200

nodejs (0.6.19~dfsg1-1) unstable; urgency=low

  * Upstream update. 

 -- Jérémy Lal <kapouer@melix.org>  Wed, 06 Jun 2012 19:11:21 +0200

nodejs (0.6.18~dfsg1-1ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

 -- James Page <james.page@ubuntu.com>  Mon, 28 May 2012 12:07:34 +0100

nodejs (0.6.18~dfsg1-1) unstable; urgency=low

  * Upstream update.
  * debian/patches:
    + 1002_make_test_not_weak.patch removed, applied upstream.
    + unfuzz patches.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 16 May 2012 02:06:42 +0200

nodejs (0.6.17~dfsg1-1ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - This package is x86/arm only. Update control to match.

