=== debian/watch ===
version=3
opts=downloadurlmangle=s/.*v(.*)\//http\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.gz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.gz/,\
dversionmangle=s/~dfsg\d+$// \
http://nodejs.org/dist v(\d+\.[02468]\.[.0-9]+)/
