## nodejs 0.8.11-maemo1

=== debian/changelog ===
nodejs (0.8.11-maemo1) unstable; urgency=low

   * 'armv7%':'1', and 'arm_neon%':'1',  (from rasberrypi)
   * LINK=g++             (cause error otherwise)
   * --without-snapshot   (cause error otherwise)
   * --prefix=/opt/node   (optifying)
   * import simplejson as json  (using python2.5, not newer)
   * use explicitely python2.5 (unless it uses python2.3)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sat, 14 Oct 2012 20:48:40 +0200
